--Load Hump Stuff

Class = require "hump.class"
gamestate = require "hump.gamestate"
Camera = require 'hump.camera'
anim8 = require 'hump.anim8'
require "gooi"



	
--texture= require  "hump.probe"


cam = Camera(340/2,244/2)
cam.smoother = Camera.smooth.linear(100)
score = 0
screenShake = 0;

function shake()
	screenShake = .3
end
--Game States
local menu = {} 
local game = {}
local calibrate = {}

w = love.graphics.getWidth();
h = love.graphics.getHeight();
buttons = {}
buttons.restart = nil;

timeCentered = 0
cam.scale = 1 * ((w)/340)

cw = (340*w)/(244*h)
ch = (244*h)/(340*w)
print(cw,ch)
print(ch*cw)
groundCanvas = love.graphics.newCanvas(340*cam.scale,244*cam.scale)
groundCanvas2 = love.graphics.newCanvas(w,h)
groundCanvas:setFilter( 'nearest', 'nearest' )
camDelta = {0,0}

asked = false
extraScore = 0;
difficultyLevel = 1; 
toMenuTime = 1

menuMode = false;

calibrate.timeZeroed = 0

sprites = {}

sprites.mapParts = {}
sprites.icon =  love.graphics.newImage('sprites/'..'icons'..'.png')

sprites.logo =  love.graphics.newImage('sprites/'..'logo'..'.png')
sprites.hands =  love.graphics.newImage('sprites/'..'hands'..'.png')
for i=6,1,-1 do 
	sprites.mapParts[i] = love.graphics.newImage('sprites/'..'1'..'.png')
	sprites.mapParts[i]:setFilter('nearest', 'nearest')
end


calibrateTime = 0;
sprites.ui = love.graphics.newImage('sprites/UI.png')
sprites.ui:setFilter('nearest', 'nearest')
uiGrid =  anim8.newGrid(40, 40, sprites.ui:getWidth(), sprites.ui:getHeight());
guageAnim = anim8.newAnimation(uiGrid('3-24',1), 0.07)
guageArmAnim = anim8.newAnimation(uiGrid(2,1), 0.07)


mainFont = love.graphics.newFont("sprites/mainFont.ttf", 12)
mainFont:setFilter( 'nearest', 'nearest' )

mainFontSmall = love.graphics.newFont("sprites/mainFont.ttf", 6)
mainFontSmall:setFilter( 'nearest', 'nearest' )

style = {
    font = mainFont,
    fgColor = "#ffffff",
    bgColor = "#218AB8ee",

}


gooi.setStyle(style)


local drawables = {}
axis1=0; axis2=0; axis3 = 0;
--Load Classes
require "runner"
require "bomb"
require "backgroundTile"

function love.load(arg)
	bombSound1 = love.audio.newSource("sounds/boom2.wav")
	bombSound2 = love.audio.newSource("sounds/boom3.wav")
	bombSound3 = love.audio.newSource("sounds/boom4.wav")
	stepSound = love.audio.newSource("sounds/footstep.wav")
	stepSound:setLooping(true)
	if love.filesystem.exists( 'BombDodger' ) then
        save = love.filesystem.read( 'BombDodger' )
		
    else
        save = 0 -- Put settings in here.
    end
	
	gamestate.registerEvents()
	gamestate.switch(calibrate)
	--gamestate.switch(game)
end
local p1 = {}
creditsVisible = false
function game:enter()

	
	
	for k, v in pairs(drawables) do		
		drawables[k]= nil
    end
	
	for i=-10,1000,1 do	
		gooi.removeComponent(i)
    end
	buttons = {}
	drawables['p1'] = Runner()
	p1 = drawables['p1']
	game.sinceLastBomb = 0
	difficultyLevel = 1
	score = 0
	nearMisses = 0
	extraScore = 0
	for i=6,1,-1 do 
		for p=6,0,-1 do
			drawables[p..'backT'..i] = BackgroundTile()
			drawables[p..'backT'..i].tileType = love.math.random(1,6)
			drawables[p..'backT'..i].x = (96*i)-300
			drawables[p..'backT'..i].y = (96*p)-300
			
		end
	end	
	
	
	if menuMode then
		if not buttons.play then

				
			if love.system.googlePlayConnect then
				if not love.system.isGooglePlayConnected() and not asked then
					love.system.googlePlayConnect()
					asked = true
				end
			
			end
	
		
			buttons.info = gooi.newButton("C", 170+75,cam.y, 25, 25):onPress(function()
				creditsVisible = true
						
				end):onRelease(function()
				creditsVisible = false
						
				end)
	
			
			buttons.services= gooi.newButton("", 170+75,cam.y, 25, 25):onRelease(function()
					if love.system.googlePlayConnect then
						if not love.system.isGooglePlayConnected() then
							love.system.googlePlayConnect()
						else
							love.system.showAchievements() 
						end
							
					
					
					end
						
				end):setIcon( "/sprites/controller.png")
			
			buttons.leaderboard =  gooi.newButton("", 170+75,cam.y, 25, 25):onPress(function()
					if love.system.googlePlayConnect then
						if not love.system.isGooglePlayConnected() then
							love.system.googlePlayConnect()
						else
							love.system.showLeaderboard("CgkIkvnE65wcEAIQAw")
						end
							
					
					
					end
						
				end):setIcon( "/sprites/leaderboard.png")
			
			
			
			buttons.play = gooi.newButton("Start", 170+75,cam.y, 110, 25):onPress(function()
				menuMode = false
				p1.dashTime = 3;
			--	if love.system.googlePlayConnect then
				--	love.system.googlePlayConnect()
			--	end
				--gamestate.switch(game);
				for i=-10,1000,1 do	

					gooi.removeComponent(i)
				end
				buttons = {}
			end)
		
		end
	end
end

timeTillAd = 2;
showingAd = false;
function game:update(dt)
	--make the runner
	if dt > .1 then
		dt = .1
	end
	
	
	
	for k, v in pairs(drawables) do		
		v:update(dt);
		if v.remove then
			drawables[k]= nil
		end
    end
	
	cam.scale = 1 * (w/340)
	cam:move((p1.x-cam.x) * (dt/.2), (p1.y-cam.y)* (dt/.2))
	
	

	
	
	if not p1.dead then
		if  menuMode == false then
			score = score+dt
			game.sinceLastBomb = game.sinceLastBomb + dt;
			
		end
		timeTillAd = 0;
		showingAd  =  false

	else		
		if timeTillAd == 0 then
		
			if love.system.createInterstitial then
				love.system.createInterstitial("ca-app-pub-7728811128155411/6486013086")
				
				
				if love.system.isGooglePlayConnected() then
					love.system.submitScore("CgkIkvnE65wcEAIQAw",  score+extraScore) 
				
				end
			end
		end
		timeTillAd = timeTillAd + dt;
		if timeTillAd > 1 then
			if love.system.createInterstitial then
				if love.system.isInterstitialLoaded() and not showingAd then
					love.system.showInterstitial() 
					showingAd = true;
				end
			end
		end
		if not buttons.restart then
			buttons.services= gooi.newButton("", 170+75,cam.y, 25, 25):onPress(function()
					if love.system.googlePlayConnect then
						if not love.system.isGooglePlayConnected() then
							love.system.googlePlayConnect()
						else
							love.system.showAchievements() 
						end
							
					
					
					end
						
				end):setIcon( "/sprites/controller.png")
			
			buttons.leaderboard =  gooi.newButton("", 170+75,cam.y, 25, 25):onPress(function()
					if love.system.googlePlayConnect then
						if not love.system.isGooglePlayConnected() then
							love.system.googlePlayConnect()
						else
							love.system.showLeaderboard("CgkIkvnE65wcEAIQAw")
						end
							
					
					
					end
						
				end):setIcon( "/sprites/leaderboard.png")
			
			buttons.restart = gooi.newButton("Again", cam.x-75,1, 75, 25):onPress(function()
					
				if love.system.createInterstitial then
					if love.system.isInterstitialLoaded()  or timeTillAd > 1 then
						gamestate.switch(game);
					end
				else
					gamestate.switch(game);
				end
				
			end)
		
			buttons.toMenu = gooi.newButton("Menu", cam.x-75,1, 75, 25):onPress(function()
					
				if love.system.createInterstitial then
					if love.system.isInterstitialLoaded()  or timeTillAd > 1 then
						menuMode =true
						gamestate.switch(game)
					end
				else
					menuMode =true
					gamestate.switch(game)
				end
				
			end)
			if math.floor(save)< score + extraScore	then
				save = math.floor(score + extraScore)
			end
			
			love.filesystem.write( 'BombDodger', tostring(math.floor(save)) )
				
				
			if love.system.googlePlayConnect then
				if love.system.isGooglePlayConnected() then
					if score+extraScore >= 1000 then
						love.system.unlockAchievement("CgkIkvnE65wcEAIQBg")
					end
					if score+extraScore >= 5000 then
						love.system.unlockAchievement("CgkIkvnE65wcEAIQBw")
					end
					if score+extraScore >= 10000 then
						love.system.unlockAchievement("CgkIkvnE65wcEAIQCA")
					end
					if nearMisses >= 10 then
						love.system.unlockAchievement("CgkIkvnE65wcEAIQCQ")
					end
					if nearMisses >= 30 then
						love.system.unlockAchievement("CgkIkvnE65wcEAIQCg")
					end
				end
			end
		
			
			
		
		end
	end
	
	if buttons.restart then
		buttons.restart.x = cam.x-80
		buttons.restart.y  = (cam.y - ((h/2) / cam.scale))  + 110
	end
	if buttons.toMenu then
		
		buttons.toMenu.x = cam.x+5
		buttons.toMenu.y  = (cam.y - ((h/2) / cam.scale))  + 110
	end
	
	
			
			
	if buttons.play then
		buttons.play.x = cam.x-55
		buttons.play.y  = (cam.y + ((h/2) / cam.scale))  -30
	end
	if buttons.services then
		buttons.services.x = cam.x-100
		buttons.services.y  = (cam.y + ((h/2) / cam.scale))  -30
		
	end
	
	if buttons.leaderboard then
		buttons.leaderboard.x = cam.x+75
		buttons.leaderboard.y  = (cam.y + ((h/2) / cam.scale))  -30
		
	end
	
	if buttons.info  then
		buttons.info.x =cam.x+75
		buttons.info.y  = (cam.y + ((h/2) / cam.scale))  -60
	end
	
	
	if buttons.play then
		buttons.play.x = cam.x-55
		buttons.play.y  = (cam.y + ((h/2) / cam.scale))  -30
	end
	if buttons.mute then
		buttons.mute.x = cam.x+60
		buttons.mute.y  = (cam.y - ((h/2) / cam.scale))  + 130
	end
	if buttons.rate then
		buttons.rate.x = cam.x+60
		buttons.rate.y  = (cam.y - ((h/2) / cam.scale))  + 170
	end
	
	
	
	
	if score > 100 then
		difficultyLevel = 2
	end
	
	
	if score > 300 then
		difficultyLevel = 3
	end
	
	if score > 600 then
		difficultyLevel = 4
	end
	
	if score > 1000 then
		difficultyLevel = 5
	end
	
	if score > 2000 then
		difficultyLevel = 6
	end
	
	if difficultyLevel == 1 then
			if game.sinceLastBomb > .6 then
		game:spawnBomb(p1.x+math.random(-70,70)+((p1.velocity.x/250)*math.random(60,170)),		
							p1.y+math.random(-70, 70)+((p1.velocity.y/250)*math.random(60,170))	,1) 			
		end
	end
	
	if difficultyLevel == 2 then
			if game.sinceLastBomb > .4 then
		game:spawnBomb(p1.x+math.random(-70,70)+((p1.velocity.x/250)*math.random(60,170)),		
							p1.y+math.random(-70, 70)+((p1.velocity.y/250)*math.random(60,170))
							,1) 
			
		end
	end
	
	
	if difficultyLevel == 3 then
			if game.sinceLastBomb > .1 then
		game:spawnBomb(p1.x+math.random(-10,10),		
							p1.y+math.random(-10, 10)
							,1) 
		end
	end
	if difficultyLevel == 4 then
			if game.sinceLastBomb > .5 then
		game:spawnBomb(p1.x+math.random(-70,70)+((p1.velocity.x/250)*math.random(60,170)),		
							p1.y+math.random(-70, 70)+((p1.velocity.y/250)*math.random(60,170))
							,1) 
			game:spawnBomb(p1.x+math.random(-70,70)+((p1.velocity.x/250)*math.random(60,170)),		
							p1.y+math.random(-70, 70)+((p1.velocity.y/250)*math.random(60,170))
							,1) 
		end
		
	end
	
	
	if difficultyLevel == 5 then
			if game.sinceLastBomb > .4 then
				game:spawnBomb(p1.x+math.random(-70,70)+((p1.velocity.x/250)*math.random(60,170)),		
								p1.y+math.random(-70, 70)+((p1.velocity.y/250)*math.random(60,170))
								,1) 
				game:spawnBomb(p1.x+math.random(-70,70)+((p1.velocity.x/250)*math.random(60,170)),		
								p1.y+math.random(-70, 70)+((p1.velocity.y/250)*math.random(60,170))
								,1) 
			end
	end
		

	if difficultyLevel == 6 then
		if game.sinceLastBomb > .4 then
			game:spawnBomb(p1.x+math.random(-70,70)+((p1.velocity.x/250)*math.random(60,170)),		
								p1.y+math.random(-70, 70)+((p1.velocity.y/250)*math.random(60,170))
								,1) 
				game:spawnBomb(p1.x+math.random(-70,70)+((p1.velocity.x/250)*math.random(60,170)),		
								p1.y+math.random(-70, 70)+((p1.velocity.y/250)*math.random(60,170))
								,1) 
					game:spawnBomb(p1.x+math.random(-70,70)+((p1.velocity.x/250)*math.random(60,170)),		
								p1.y+math.random(-70, 70)+((p1.velocity.y/250)*math.random(60,170))
								,1) 	
		end
	end
	
	guageAnim:gotoFrame(math.floor(p1.dashTime*21/3)+1)
	mouseX,mouseY =  cam:worldCoords(love.mouse.getPosition())
  
end

mouseX = 0
mouseY  = 0
function game:draw()

	--draw all the drawables 
	
	love.graphics.clear(0,200,0)
	
	love.graphics.setCanvas(groundCanvas)
	love.graphics.push(); 
	love.graphics.scale(cam.scale)

	for k, v in pairs(drawables) do	
		if v.depth == 0 then
			v:draw();
		end
    end
		love.graphics.setCanvas()
			
love.graphics.pop(); 
	love.graphics.push(); 

love.graphics.setCanvas(groundCanvas2)
--	 texture.quad(groundCanvas,
--		 {0,0},
--		 {w,0},
--		 {(w)+(100*cam.scale),(244*cam.scale)+10},
--		 {-100*cam.scale, (244*cam.scale)+10})
	love.graphics.pop();


love.graphics.setCanvas();

if screenShake>0 then
		love.graphics.translate((math.random() - .5)*4,( math.random() - .5)*4)
	end
	--love.graphics.draw(groundCanvas2)
	cam:attach()
	love.graphics.draw(groundCanvas,cam.x-170,cam.y-122,0,1/cam.scale)
	
	love.graphics.setCanvas(groundCanvas)
	love.graphics.clear();
	love.graphics.setCanvas();
	--texture.cw=false
 --texture.setRepeat({1,1},{.5,.5})

	
	
	for k, v in pairs(drawables) do	
		if v.depth == 1 then
			v:draw();
		end
    end
	for k, v in pairs(drawables) do	
		if v.depth == 2 then
			v:draw();
		end
    end
	love.graphics.setShader()
	
	if score ~= nil then
		if not menuMode then
		str =string.gsub( string.format("%09d", score+extraScore), '0', 'o')
		
		love.graphics.setFont(mainFont)
			love.graphics.setColor(0,0,0,255);
		love.graphics.print(str, 			
			cam.x -1- mainFont:getWidth(str)/2 , 
			(cam.y - ((h/2) / cam.scale)) + 12)
		
		love.graphics.setColor(255,255,255,255);
		love.graphics.print(str, 			
			cam.x - mainFont:getWidth(str)/2 , 
			(cam.y - ((h/2) / cam.scale)) + 10)
	
		end
	end
	
--	guageAnim:draw(sprites.ui, cam.x-142,cam.y+96, 0,1,1,18,17)
--	guageArmAnim:draw(sprites.ui, cam.x-142+.5,cam.y+96-.5, p1.x,1,1,18.5,17.5)
	
	
	--guageAnim:draw(sprites.ui, cam.x-(w/cam.scale/2)+23,cam.y+(h/cam.scale/2)-23, 0,1,1,18,17)
	if p1.dead then
	love.graphics.setColor(0,0,0,255);
		love.graphics.rectangle('fill', cam.x-90-3, (cam.y - ((h/2) / cam.scale)) + 40-3, 180+6, 100+6, 5, 5, 25 )

	love.graphics.setColor(124,204,195,155);
	love.graphics.rectangle('fill', cam.x-90, (cam.y - ((h/2) / cam.scale)) + 40, 180, 100, 2, 2, 25 )
	
		str =string.gsub( 'Top Score\n\n'..string.format("%09d", save), '0', 'o')
		
		love.graphics.setFont(mainFont)
			love.graphics.setColor(0,0,0,255);
		love.graphics.print(str, 			
			cam.x -1- mainFont:getWidth(str)/2 , 
			(cam.y - ((h/2) / cam.scale)) + 62)
		
		love.graphics.setColor(255,255,255,255);
		love.graphics.print(str, 			
			cam.x - mainFont:getWidth(str)/2 , 
			(cam.y - ((h/2) / cam.scale)) + 60)
		
		
		
end

if menuMode then
		str =string.gsub( 'Top Score\n\n'..string.format("%09d", save), '0', 'o')
		love.graphics.scale(.5)
		love.graphics.setFont(mainFont)
			love.graphics.setColor(0,0,0,255);
		love.graphics.print(str, 			
			(cam.x + 150 -1- mainFont:getWidth(str)/2)* (1/.5) , 
			((cam.y - ((h/2) / cam.scale))+ 10)* (1/.5))
		
		love.graphics.print("      Avoid the bombs\nrotate phone to move", 			
			(cam.x - mainFont:getWidth(      "Avoid the bombs\nrotate phone to move")/4)* (1/.5) , 
			((cam.y + ((h/2) / cam.scale))  -48)* (1/.5))
		
		love.graphics.setColor(255,255,255,255);
		
		
		
		love.graphics.print(str, 			
			(cam.x+ 150 - mainFont:getWidth(str)/2 )* (1/.5), 
			((cam.y - ((h/2) / cam.scale)) + 9) * (1/.5))
		
		love.graphics.print("      Avoid the bombs\nrotate phone to move", 			
			(cam.x +1- mainFont:getWidth(      "Avoid the bombs\nrotate phone to move")/4)* (1/.5) , 
			((cam.y + ((h/2) / cam.scale))  -49)* (1/.5))
		
		
		
		love.graphics.scale(1/.5)
		love.graphics.draw(sprites.logo, cam.x-86,	((cam.y - ((h/2) / cam.scale)) + 4), 0,.2,.2)
end
	 gooi.draw()
	
	
		
		
	
	if creditsVisible then
		love.graphics.setColor(0,0,0,255);
		love.graphics.rectangle('fill', cam.x-120-3, (cam.y - ((h/2) / cam.scale)) + 5-3, 240+6, 200+6, 5, 5, 25 )

		love.graphics.setColor(124,204,195,155);
		love.graphics.rectangle('fill', cam.x-120, (cam.y - ((h/2) / cam.scale)) + 5, 240, 200, 2, 2, 25 )
	
	
		str ='This game uses resources\n\nfrom Open Game Art created by\n\nthe following users\n\n'..
		'\n\nGuillaume Lecollinet  .  BrowserQuest'..
		'\n\nLittle Robot Sound Factory  .  Fantasy Sound'..
		'\n\nhelpcomputer  .  Explosions'..
		'\n\nGrafxKid  .  Classic Hero'..
		'\n\nChrisblue  .  Bombs'..
		'\n\nDistributed under CC BY 3 0 '..
		'\n\n\n\nThank you for your contributions'..
		'\n\nGame designed by Matthew Fearrington'
		
		love.graphics.setFont(mainFontSmall)
			love.graphics.setColor(0,0,0,255);
		love.graphics.print(str, 			
			cam.x -1- mainFontSmall:getWidth(str)/2 , 
			(cam.y - ((h/2) / cam.scale)) + 10)
		
		love.graphics.setColor(255,255,255,255);
		love.graphics.print(str, 			
			cam.x - mainFontSmall:getWidth(str)/2 , 
			(cam.y - ((h/2) / cam.scale)) + 10)
	end
	
	
	
	love.graphics.setColor(0,0,0,255);
	
	--[[love.graphics.print("DANGER", 			
			(cam.x -142 - mainFont:getWidth("DANGER")/4)*2 , 
			(cam.y + 71 )*2)
	love.graphics.setColor(255,255,255,255);
		love.graphics.print("DANGER", 			
			(cam.x -142 - mainFont:getWidth("DANGER")/4)*2 , 
			(cam.y + 70 )*2)]]--
	cam:detach()
	
	
	
end

function game:spawnBomb(x,y,tminus,noReset) 
	 noReset = noReset or false
	local nBomb = Bomb()
	nBomb.x, nBomb.y = x,y
	nBomb.tminus = tminus
	nBomb:init();
	nBomb.p1 = drawables['p1'] ;
	table.insert(drawables, nBomb)
	if not noReset then
		game.sinceLastBomb = 0
	end
end
function game:mousepressed(x,y,b)
	local xx, yy = cam:worldCoords(x,y)
	--game:spawnBomb(xx,yy,3) 
	--p1.dashing = true
end
function game:mousereleased(x,y,b)
	--local xx, yy = cam:worldCoords(x,y)
	--game:spawnBomb(xx,yy,3) 
	p1.dashing = false
end







function calibrate:update(dt)
cam.scale = 1 * (w/340)
calibrateTime= calibrateTime + dt


	if timeCentered<4 then
		if axis1 ==0 and axis2 == 0 then
			timeCentered =  timeCentered + dt
		else
			timeCentered =  0
		end
	else
		toMenuTime = toMenuTime - dt
		if toMenuTime < 0 then
			menuMode = true
			gamestate.switch(game)
			
		end
	end	
end

function calibrate:draw()
	--draw all the drawables 
	love.graphics.clear(0, 0, 0)
	cam:attach()
	

	love.graphics.setColor(255,255,255,100)
	love.graphics.draw(sprites.mapParts[1], 0, 95*0)
	love.graphics.draw(sprites.mapParts[1], 0, 95*1)
	love.graphics.draw(sprites.mapParts[1], 0, 95*2)
	love.graphics.draw(sprites.mapParts[1], 0, 95*3)
	
	love.graphics.draw(sprites.mapParts[1], 96*1, 95*0)
	love.graphics.draw(sprites.mapParts[1], 96*1, 95*1)
	love.graphics.draw(sprites.mapParts[1], 96*1, 95*2)
	love.graphics.draw(sprites.mapParts[1], 96*1, 95*3)
	
	love.graphics.draw(sprites.mapParts[1], 96*2, 95*0)
	love.graphics.draw(sprites.mapParts[1], 96*2, 95*1)
	love.graphics.draw(sprites.mapParts[1], 96*2, 95*2)
	love.graphics.draw(sprites.mapParts[1], 96*2, 95*3)
	
	love.graphics.draw(sprites.mapParts[1], 96*3, 95*0)
	love.graphics.draw(sprites.mapParts[1], 96*3, 95*1)
	love.graphics.draw(sprites.mapParts[1], 96*3, 95*2)
	love.graphics.draw(sprites.mapParts[1], 96*3, 95*3)
	
	love.graphics.setColor(255,255,255,255)
	
	
	
	
	if calibrateTime <1 then
		
		love.graphics.draw(sprites.icon, cam.x-24, cam.y-24,0,.25,.25)
	
		love.graphics.draw(sprites.icon, cam.x-24, cam.y-24,0,.25,.25)
	else

	if not Gyro then
		--love.graphics.printf('Hold phone like this', 170-1000, 34,2000,'center')
		love.graphics.setColor(0,0,0,255);
		love.graphics.printf('This game requires an accelerometer to play.', 170-1000-2, 170+2,2000,'center')
		love.graphics.setColor(255,255,255,255);
		love.graphics.printf('This game requires an accelerometer to play.', 170-1000, 170,2000,'center')
		cam:detach()
		return;
	end
	
	
		local trueTime = calibrateTime-1
		love.graphics.setColor(255,255,255,255-(255*trueTime));
		

		love.graphics.draw(sprites.icon, cam.x-24, cam.y-24-(50*trueTime),0,.25,.25)
		if trueTime > 1 then
			trueTime =1
		end
		love.graphics.setColor(89,89,89,255*trueTime);	
		love.graphics.circle('fill',170,122,20)
		
		love.graphics.setColor(22,22,22,255*trueTime);	
		
		love.graphics.circle('fill',170,122,7 )
		
		
		love.graphics.setColor(0,0,255,255*trueTime);	
		love.graphics.circle('fill',170+(axis1*30),122+(axis2*30),(15* (timeCentered/4))+5 )
		
		
		
		love.graphics.setColor(0,0,0,255*trueTime);
		love.graphics.circle('fill',170-1+(axis1*30),122+1+(axis2*30),5)
		love.graphics.setColor(255,255,255,255*trueTime);
		love.graphics.circle('fill',170+(axis1*30),122+(axis2*30),5)
		
		
		love.graphics.setColor(0,0,0,255*trueTime);
		love.graphics.draw(sprites.hands, cam.x-3-(sprites.hands:getWidth()/4), cam.y-90+1,0,.5,.5) 
		love.graphics.setColor(255,255,255,255*trueTime);
		love.graphics.draw(sprites.hands, cam.x-2-(sprites.hands:getWidth()/4), cam.y-90,0,.5,.5) 
		
		love.graphics.setFont(mainFont)
		--love.graphics.printf('Hold phone like this', 170-1000, 34,2000,'center')
		love.graphics.setColor(0,0,0,255*trueTime);
		love.graphics.printf('Hold phone sideways\n\nCenter the cirle to begin', 170-1000-2, 170+2,2000,'center')
		love.graphics.setColor(255,255,255,255*trueTime);
		love.graphics.printf('Hold phone sideways\n\nCenter the cirle to begin', 170-1000, 170,2000,'center')
	end

	love.graphics.setColor(255,255,255,(1-toMenuTime) * 255)
	love.graphics.rectangle('fill', -100,-100,1000,1000)
	
	
	cam:detach()
end
Gyro = false

function love.update(dt)
screenShake =  screenShake - dt
	local joysticks = love.joystick.getJoysticks()
	local axes = {}
    for i, joystick in ipairs(joysticks) do
			axis1, axis2, axis3 = joystick:getAxes()
			if axis2 then			
			
				
				axis2 = axis2	
			end
		if string.match(joystick:getName(), "Android") or love.system.googlePlayConnect == nil  then
			Gyro = true;
			axis2 = axis2-.75
			break;
			
		end
    end

	if Gyro == false and love.system.googlePlayConnect  then
		axis2 = axis2-.6
		return
	end
	
	if  love.system.googlePlayConnect == nil then
		Gyro = true
		axis1 = 0
		axis2 = 0
		if love.keyboard.isDown('left') then
			axis1 = -.9
		end
		if love.keyboard.isDown('right') then
			axis1 = .9
		end
		if love.keyboard.isDown('up') then
			axis2 = -.9
		end
		if love.keyboard.isDown('down') then
			axis2 = .9
		end
		return
	end

	if gamestate.current() == game then
		axis2 = axis2 * 16
		axis1 = axis1 * 13
	else
			axis2 = axis2 * 3
		axis1 = axis1 * 3
		if math.abs(axis1)< .3 and math.abs(axis2)< .3 then
		axis1 = 0
		axis2 = 0
	end
end


	if axis1 < -1 then
		axis1 = -1
	end
	if axis1 > 1 then
		axis1 = 1
	end
	if axis2 < -1 then
		axis2 = -1
	end
	if axis2 > 1 then
		axis2 = 1
	end

	if math.abs(axis1)< .15 and math.abs(axis2)< .15 then
		axis1 = 0
		axis2 = 0
	end
end

-- Callback function triggered when window receives or loses focus
-- @param(f : boolean) window focus
function love.focus(f)

end



function love.mousepressed(x, y, b)
	
	if gamestate.current() == calibrate then
	--	p1.dashing = true;
	--	menuMode = true
	--	gamestate.switch(game)
	elseif gamestate.current() == game  then
		--p1.dashing = true;
	end	
	if  love.system.googlePlayConnect == nil then
			gooi.pressed(nil,mouseX,mouseY)	
	end

end
function love.mousereleased(x, y, b)
	
		if  love.system.googlePlayConnect == nil   then
			gooi.released(nil,mouseX,mouseY)
	end

		creditsVisible = false
	
	p1.dashing = false;
end

function love.quit()




	return false
end


function love.draw(dt)
  
	 
end


function love.touchpressed(id, x, y, dx, dy, pressure)
	--p1.dashing = true
	
		mouseX,mouseY =  cam:worldCoords(x,y)
	gooi.pressed(id,mouseX,mouseY)	

	--gamestate.switch(game);	
		
end

function love.touchreleased(id, x, y, dx, dy, pressure)
	p1.dashing = false
	creditsVisible = false
	mouseX,mouseY =  cam:worldCoords(x,y)
	gooi.released(id,mouseX,mouseY)	
end

function love.touchmoved(id, x, y, dx, dy, pressure)

end

