sprites.features = love.graphics.newImage('sprites/features.png')


BackgroundTile = Class{
    init = function(self)

		if math.random() < .1 then
			self.feature = anim8.newAnimation(self.fGrid(3,1), 0.08)
			self.featurePos.x = love.math.random(1,60)
		self.featurePos.y = love.math.random(1,60)
		end
	
    end,
    depth = 0;
	x = 0;
	y = 0;
	tileType = 1;
	feature = nil;
	featurePos = {};
	fGrid = anim8.newGrid(32, 32, sprites.features:getWidth(), sprites.features:getHeight());
}

function BackgroundTile:update(dt)
	if self.featurePos.x == 1 then
		
	end
	if (self.x+100) < cam.x - 170 then
		self.x = self.x + 480
	end
	
	if (self.x) > cam.x + 170 then
		self.x = self.x - 480
	end
	
	
	if (self.y+100) < cam.y - 122 then
		self.y = self.y + 380
	end
	
	if (self.y) > cam.y + 122 then
		self.y = self.y - 380
	end
end

function BackgroundTile:draw()
	love.graphics.setColor(255,255,255,255)
	
	love.graphics.draw(sprites.mapParts[self.tileType],math.floor(self.x-cam.x+170),math.floor(self.y-cam.y+122),0)
	
	
end


